'////////////////////////////////////////////////////////////////////////////////
'//
'//        Author:   Mick.George@Mastercam.com
'//          Date:   03/11/2003 02:44 PM
'//     File Name:   Arcs Grid.vbs
'//
'//   Description:   Creates a grid pattern of holes from X0 Y0
'//
'//      Comments:   Validated version X8 
'//
'////////////////////////////////////////////////////////////////////////////////

' -- Start Script
Call Main()                

' ////////////////////
' Sub Declaration
' ////////////////////
Sub Main()

Dim intYHoles, intXHoles
  
' -- Clear screen
Call NewMC(False)

' -- How many holes do you want?
If askNumber("How many holes in grid", 10, 500, intXHoles) Then
      Call CreateHoles(intXHoles, intYHoles)
Else
 ' -- Bail...  
  Exit Sub 
End If   

End Sub               



' ////////////////////
' Sub Declaration
' ////////////////////
Sub CreateHoles(NumHolesX, NumHolesY)

Dim CHoles
Dim intRet
Dim intRow
Dim intCol

' -- Create a new instance of a Mastercam Arc class object
Set CHoles = New McAr  


With CHoles
     .Z = 0
     .R = .1875
     .SA = 0
     .SW = 360
     
     ' ################
     ' ### 1st Grid ###
     ' ################   
      For intCol = 0 To NumHolesX  - 2 Step .86602 ' -- Columns 
        For intRow = 0 To NumHolesX - 1            ' -- Rows
     
          .Y = (.5 * intRow) 
          .X = intCol 
               
          ' -- Create the line
          intRet = CreateArc(CHoles, mcCOLOR_RED, 2)     

        Next
     Next       

     ' ################
     ' ### 2nd Grid ###
     ' ################
     For intCol = .433 To NumHolesX -2   Step .86602 ' -- Columns 
        For intRow = .5 To NumHolesX  -1             ' -- Rows
     
          .Y = (.5 * intRow)
          .X = intCol
               
          ' -- Create the line
          intRet = CreateArc(CHoles, mcCOLOR_WHITE, 3)     

        Next
     Next

End With       
  

' -- Clean Up
Set CHoles = Nothing


End Sub


