'////////////////////////////////////////////////////////////////////////////////
'//
'//        Author:   Mick.George@Mastercam.com
'//          Date:   07/05/2004 09:17 AM
'//     File Name:   ArrayRectangles.vbs
'//
'//   Description:   ARRAYRECTANGLES.VBS
'//
'//      Comments:   Prompts for a rectangle size, fillet and spacing and then 
'//                  creates them in an array. 
'//                  Validated version X8 
'//
'////////////////////////////////////////////////////////////////////////////////


' -- Start Script
Call Main()


' ////////////////////
' Sub Declaration
' ////////////////////
Sub Main()
    
Dim CRect
Dim iX, iY, dblWidth, dblHeight, dblDistX, dblDistY, dblFillet, intCount

' -- Initialize
dblWidth = 10.0
dblHeight = 10.0
dblDistX = 2.0
dblDistY = 2.0
dblFillet = 0.5
intCount = 20

' -- Ask our user for some values
If Not askValue("Please input width of rectangle", 1 , 100, dblWidth) Then Exit Sub
If Not askValue("Please input height of rectangle", 1 , 100, dblHeight) Then Exit Sub
If Not askValue("Please input fillet of rectangle", 0 , 5, dblFillet) Then Exit Sub

If Not askNumber("How many rectangles along the X and Y axis?", 1 , 100, intCount) Then Exit Sub

If Not askValue("Please input X spacing of rectangle", 1 , 100, dblDistX) Then Exit Sub
If Not askValue("Please input Y spacing of rectangle", 1 , 100, dblDistY) Then Exit Sub

' -- Set up the screen
Call NewMC(False)


For iX = 0 To intCount - 1

  For iY = 0 To intCount -1

    Set CRect = New McRe
  
    With CRect
         .X1 = iX * (dblWidth + dblDistX)
         .Y1 = iY * (dblHeight + dblDistY)
         
         .X2 = .X1 + dblWidth   
         .Y2 = .Y1 + dblHeight
    End With 
    
   If CreateRectangleWithFillets(CRect, dblFillet, mcCONSTRUCTION_COLOR_CURRENT, _
                                 mcCONSTRUCTION_LEVEL_CURRENT) = mcENTITY_INVALID Then
    ShowString "Failed to created rectangle"
    Exit Sub
   End If
    
  Next
  
Next  
    
Call RepaintScreen(True)
    
End Sub



