'////////////////////////////////////////////////////////////////////////////////
'//
'//        Author:   Mick George Mick.George@Mastercam.com
'//          Date:   05/11/2003 04:42 PM
'//     File Name:   Copy Entities to Level.vbs
'//
'//   Description:   
'//
'//      Comments:   Select an entity to get its level, prompt for a new level and copy all
'//                  entities from current level to new level. 
'//
'////////////////////////////////////////////////////////////////////////////////
 
' 
Const DEF_GIVE_ME_EVERYTHING = -1

' -- Start Script
Call Main()


' ////////////////////
' Sub Declaration
' ////////////////////
Sub Main()   

Dim CArc, CLine, CPoint, CRect
Dim CArcCopy, CLineCopy, CPointCopy, CRectCopy    
Dim intOriginalLevel, intNewLevel  
Dim bRet

If Not IsDrawing Then ShowString "We need a drawing": Exit Sub
  
If AskForEntity("Select an entity to copy, all entities on the same level will also be copied.", mc_arctype + mc_linetype + mc_recttype + mc_pointtype) Then
   ' -- Store this entities level for eval
   intOriginalLevel = GetEntityLevel  

   If askLevel(intNewLevel) Then
      ' -- Loop through all entities on original level and 
      ' -- make a copy of it on the new level.
      bRet = StartDBSearch(mc_alive, DEF_GIVE_ME_EVERYTHING)

      Do 

         Select Case GetEntityType 

                Case mc_arctype 

                    ' -- Is this arc on the same level?
                    If intOriginalLevel = GetEntityLevel Then  

                        Set CArc = New McAr
                        Set CArcCopy = New McAr
    
                        ' -- Get this arc
                        If GetArcData(GetEntityEptr, CARC) Then
                           ' -- Copy properties to our new arc
                           With CArcCopy
                                .X    = CArc.X
                                .Y    = CArc.Y
                                .Z    = CArc.Z
                                .R    = CArc.R
                                .SA   = CArc.SA
                                .SW   = CArc.SW
                                .VIEW = CArc.VIEW
                           End With
                           
                           ' -- Create our new arc on our new level
                           If CreateArc(CArcCopy, mcCOLOR_WHITE, intNewLevel) = mcENTITY_INVALID Then      
                              ' -- Call the police, we have a situation... 
                              ShowString "Could not create copy of Arc"
                              Exit Sub
                           End If
    
                        Else
                          ' -- OMG 
                          ShowString "Could not get current Arc"
                          Exit Sub
                        End If    
                    End If


                Case mc_linetype             
                    
                    ' -- Is this line on the same level?
                    If intOriginalLevel = GetEntityLevel Then 

                        Set CLine = New McLn
                        Set CLineCopy = New McLn
    
                        ' -- Get this line
                        If GetLineData(GetEntityEptr, CLine) Then
                           ' -- Copy properties to our new line
                           With CLineCopy
                                .X1    = CLine.X1
                                .Y1    = CLine.Y1
                                .Z1    = CLine.Z1
                                .X2    = CLine.X2
                                .Y2    = CLine.Y2
                                .Z2    = CLine.Z2
                           End With
                           
                           ' -- Create our new arc on our new level
                           If CreateLine(CLineCopy, mcCOLOR_WHITE, intNewLevel) = mcENTITY_INVALID Then      
                              ' -- Call the police, we have a situation... 
                              ShowString "Could not create copy of Line"
                              Exit Sub
                           End If
    
                        Else
                          ' -- OMG 
                          ShowString "Could not get current Line"
                          Exit Sub
                        End If    
                    End If


                Case mc_pointtype    

                    ' -- Is this point on the same level?
                    If intOriginalLevel = GetEntityLevel Then               

                        Set CPoint = New McLn
                        Set CPointCopy = New McLn
    
                        ' -- Get this point
                        If GetPointData(GetEntityEptr, CPoint) Then
                           ' -- Copy properties to our new point
                           With CPointCopy
                                .X    = CPoint.X
                                .Y    = CPoint.Y
                                .Z    = CPoint.Z
                           End With
                           
                           ' -- Create our new arc on our new level
                           If CreateLine(CPointCopy, mcCOLOR_WHITE, intNewLevel) = mcENTITY_INVALID Then      
                              ' -- Call the police, we have a situation... 
                              ShowString "Could not create copy of Point"
                              Exit Sub
                           End If
    
                        Else
                          ' -- OMG 
                          ShowString "Could not get current Point"
                          Exit Sub
                        End If    
                     End If

                 Case mc_recttype    

                    ' -- Is this rectangle on the same level?
                    If intOriginalLevel = GetEntityLevel Then    

                        Set CRect = New McLn
                        Set CRectCopy = New McLn
    
                        ' -- Get this rect
                        If GetRectangleData(GetEntityEptr, CRect) Then
                           ' -- Copy properties to our new rect
                           With CRectCopy
                                .X1    = CRect.X1
                                .Y1    = CRect.Y1
                                .X2    = CRect.X2
                                .Y2    = CRect.Y2
                                .Z     = CRect.Z
                           End With
                           
                           ' -- Create our new arc on our new level
                           If CreateRectangle(CRectCopy, mcCOLOR_WHITE, intNewLevel) = mcENTITY_INVALID Then      
                              ' -- Call the police, we have a situation... 
                              ShowString "Could not create copy of Rectangle"
                              Exit Sub
                           End If
    
                        Else
                          ' -- OMG 
                          ShowString "Could not get current Rectangle"
                          Exit Sub
                        End If    
                     End If



         End Select

         bRet = NextDBSearch    

      Loop While bRet     
                              
      Call UnselectAll     
      Call RepaintScreen(True)     


   Else
     ' -- Bail...
     Exit Sub
   End If   






End If   



   

End Sub

' ////////////////////
' Function Declaration
' ////////////////////

Function IsDrawing()

Dim Ret

Ret = StartDBSearch(mc_alive, -1) 

UnselectAll

IsDrawing = Ret

End Function
