'////////////////////////////////////////////////////////////////////////////////
'//
'//        Author:   Mick.George@Mastercam.com
'//          Date:   27/10/2003 02:45 PM
'//     File Name:   Delete_Entity.vbs
'//
'//   Description:   Prompts for a single entity and deletes it, then prompts for multiple entities and deletes them
'//
'//      Comments:   DeleteAllSelectedEntities() returns false if successfull (update pending) 
'//                  Screen-Statistics from main menu does not reflect the deleted arcs???
'//
'//                 Verified version X8
'////////////////////////////////////////////////////////////////////////////////


' -- Start Script
Call Main()


' ////////////////////
' Sub Declaration
' ////////////////////
Sub Main()
                 
Dim bRet
Dim intArcCount
 
   If IsDrawing Then Call InitializeScreen()

   Call CreateHoles 

   Call GetReady

   Call ShowString("12 Arcs created")

   If AskForEntity("***** SELECT AN ARC ******", mc_arctype) Then

      ' -- Delete the selected entity  
      If DeleteEntity(GetEntityEptr) Then
      Call RunFTCommand("Mastercam", "OnScreenRegenerate")
         ShowString "Arc has been deleted"
      Else
         ShowString "Call to DeleteEntity failed"
      End If 

   End If

   Call GetReady

   bRet = MarkWindow("**** WINDOW SOME ARCS *****", mc_arctype, mcWINDOW_INSIDE) 
   
   If bRet Then

      If DeleteAllSelectedEntities Then
         ShowString "Arcs has been deleted" 
         Call RunFTCommand("Mastercam", "OnScreenRegenerate")
      Else
         ShowString "Call to DeleteAllSelectedEntities failed but not really :D"
      End If

   End If

   Call GetReady      

   ' -- Search back through database looking for arcs
   bRet = StartDBSearch(mc_alive, mc_arctype)

   If bRet Then
                                   
      Do While bRet
          ' -- Keep a running total
          intArcCount = intArcCount + 1
          
          bRet = NextDBSearch     
      Loop
                                       
      Call ShowString((12 - intArcCount) & " arcs total were deleted")

   Else
      Call ShowString("All arcs were deleted")
   End If
     


End Sub   



' ////////////////////
' Sub Declaration
' ////////////////////
Sub CreateHoles

Dim CHoles
Dim intRet
Dim intRow
Dim intCol

' -- Create a new instance of a Mastercam Arc class object
Set CHoles = New McAr  


With CHoles
     
     .Z = 0
     .R = .0984 ' -- 5mm
     .SA = 0
     .SW = 360
     
     ' ###################
     ' ### Shelf holes ###
     ' ###################
         
     For intCol = 1 To 12 Step 6 ' -- Create two columns 6" apart
        For intRow = 2 To 7      ' -- Create 6 holes 5mm dia * 32mm apart
     
          .Y = (1.2598 * intRow)
          .X = intCol
               
          ' -- Create the line
          intRet = CreateArc(CHoles, mcCONSTRUCTION_COLOR_CURRENT, mcCONSTRUCTION_LEVEL_CURRENT)     

        Next
     Next
     
End With       

 

' -- Clean Up
Set CHoles = Nothing


End Sub


' ////////////////////
' Function Declaration
' ////////////////////

Function IsDrawing()

Dim Ret

Ret = StartDBSearch(mc_alive, -1)

IsDrawing = Ret

End Function


' ////////////////////
' Function Declaration
' ////////////////////
Function InitializeScreen()

If askYesNo("Clear Memory?") Then
  Call NewMC(false)
End If

End Function


' ////////////////////
' Sub Declaration
' ////////////////////
Public Sub GetReady
    Call UnselectAll  
    Call RepaintScreen(True)
End Sub

