'////////////////////////////////////////////////////////////////////////////////
'//
'//        Author:   Mick.George@Mastercam.com
'//          Date:   06/03/2008
'//     File Name:   GetJobInformation.vbs
'//
'//   Description:   Gets current job information and dumps it to an html file and 
'//                  then, lord willing, loads up IE and displays it.
'//
'//      Comments:   Only tested under IE may look like craaaap in anything else 
'//
'//                  Verified version X8
'////////////////////////////////////////////////////////////////////////////////

' -- Start Script
Call Main()


' ////////////////////
' Sub Declaration
' ////////////////////
Sub Main()     

Dim strCurrentFileName, strReportName
Dim strHTML, strOpComment
Dim FSO, fsoReport
Dim intOperations, intOpCount, strOperationName, ToolNumber, strToolComment
Dim dblTemp
Dim intOpTypeId 


' -- Prompt for a report name
strReportName = AskString("Input name of report", "") 

If Len(Trim(strReportName)) = 0 Then Exit Sub

' -- Check for EXT
If Len(strReportName) <= 5 Then
   strReportName = strReportName & ".html"
Else
   If Right(LCase(strReportName), 5) <> ".html" Then strReportName = strReportName & ".html"
End If

Call ClearPromptLines   
Call WriteString("Generating report, please wait....")

Set FSO = CreateObject("Scripting.FileSystemObject")

' -- Get the file's name
strCurrentFileName = GetCurrentFileName   

' -- Make sure we are in ISO view
Call SetGViewNumber(mcVIEW_ISO)        

' -- Generate bitmap image of part
Call DoBitmapfile(vbNullString, GetPath & "IMAGE.BMP")

' -- Store path to out report                        
strHTML = GetPath &  strReportName

'ShowString "GetJobSetupMaterial = " & GetJobSetupMaterial
'
'ShowString "GetJobSetupStockOriginX = " & GetJobSetupStockOriginX
'ShowString "GetJobSetupStockOriginY = " & GetJobSetupStockOriginY
'ShowString "GetJobSetupStockOriginZ = " & GetJobSetupStockOriginZ
'
'ShowString "GetJobSetupStockSizeX = " & GetJobSetupStockSizeX
'ShowString "GetJobSetupStockSizeY = " & GetJobSetupStockSizeY
'ShowString "GetJobSetupStockSizeZ = " & GetJobSetupStockSizeZ


' -- Create our html file
Set fsoReport = FSO.CreateTextFile(strHTML)       

With fsoReport                                                  
    .WriteLine "<!DOCTYPE HTML PUBLIC " & Chr(34) & "-//W3C//DTD HTML 4.0 Transitional//EN " & Chr(34) & ">"
    .WriteLine "<HTML>"
    .WriteLine "<HEAD>"
    .WriteLine "<TITLE>Mastercam Job Setup Sheet</TITLE>"
    .WriteLine "</HEAD>"
    .WriteLine "<BODY BGCOLOR = " & Chr(34) & "white" & Chr(34) & "><BODY>" 

    .WriteLine "<td width=" & Chr(34) & "287" & Chr(34) & "><a href=" & Chr(34) & "http://www.mastercam.com" & Chr(34) & "><img src=" & Chr(34) & "https://secure.mastercam.com/images/logo.gif" & Chr(34) & " width=" & Chr(34) & "287" & Chr(34) & " height=" & Chr(34) & "65" & Chr(34) & " border=" & Chr(34) & "0" & Chr(34)  & " align=" & Chr(34) & "left" & Chr(34) & " alt=" & Chr(34) & "Mastercam.com" & Chr(34) & "></a>"
    .WriteLine "</table>"
    .WriteLine "<font color=" & Chr(34) & "#A72934" & Chr(34) & ">"
    .WriteLine "<MARQUEE id=Marquee3 style=" & Chr(34) & "WIDTH: 300px; HEIGHT: 13px" & Chr(34) & " trueSpeed scrollAmount=3 scrollDelay=3 behavior=slide Loop=1><SPAN Class=564313111-17052002>CNC Software, Inc</SPAN></MARQUEE><BR>"
    .WriteLine "<MARQUEE id=Marquee3 style=" & Chr(34) & "WIDTH: 300px; HEIGHT: 13px" & Chr(34) & " trueSpeed scrollAmount=2 scrollDelay=3 behavior=slide Loop=1><SPAN Class=564313111-17052002>671 Old Post Road</SPAN></MARQUEE><BR>"
    .WriteLine "<MARQUEE id=Marquee3 style=" & Chr(34) & "WIDTH: 300px; HEIGHT: 13px" & Chr(34) & " trueSpeed scrollAmount=1 scrollDelay=2 behavior=slide Loop=1><SPAN Class=564313111-17052002>Tolland, CT 06084</SPAN></MARQUEE><BR>"
    .WriteLine "</font>"
    .WriteLine "<BR><BR>"
    .WriteLine strCurrentFileName 
    .WriteLine "<BR><BR>"

    .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & "><img src=" & Chr(34) & "IMAGE.BMP" & Chr(34) & " border=" & Chr(34) & "1" & Chr(34) & Chr(34) & " align=" & Chr(34) & "left" & Chr(34) & "></a></td>"

    .WriteLine "<table width = " & Chr(34) & "50%" & Chr(34) & " border=" & Chr(34) & "1" & Chr(34) & " cellspacing=" & Chr(34) & "1" & Chr(34) & " cellpadding=" & Chr(34) & "0" & Chr(34) & " bordercolorlight=" & Chr(34) & "#C0C0C0" & Chr(34) & " bordercolordark=" & Chr(34) & "#A72934" & Chr(34) & ">"
    .WriteLine "<tr>"    
        .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & "><b>Material:</b></td>"
        .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & ">" & GetJobSetupMaterial  & Chr(34) & "</td>"
    .WriteLine "</tr>"

    .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & "><b><u>Origin</u></b></td>"

    .WriteLine "<tr>"
        .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & "><b>X:</b></td>"
        .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & ">" & GetJobSetupStockOriginX & Chr(34) & "</td>"
    .WriteLine "</tr>"

    .WriteLine "<tr>"
        .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & "><b>Y:</b></td>"
        .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & ">" & GetJobSetupStockOriginY & Chr(34) & "</td>"
    .WriteLine "</tr>"

    .WriteLine "<tr>"
        .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & "><b>Z:</b></td>"
        .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & ">" & GetJobSetupStockOriginZ & Chr(34) & "</td>"
    .WriteLine "</tr>"

    .WriteLine "<tr>"          
        .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & "><b><u>Size</u></b></td>"
    .WriteLine "</tr>"

    .WriteLine "<tr>"          
        .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & "><b>X:</b></td>"
        .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & ">" & GetJobSetupStockSizeX & Chr(34) & "</td>"
    .WriteLine "</tr>"

    .WriteLine "<tr>"
        .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & "><b>Y:</b></td>"
        .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & ">" & GetJobSetupStockSizeY & Chr(34) & "</td>"
    .WriteLine "</tr>"

    .WriteLine "<tr>"
        .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & "><b>Z:</b></td>"
        .WriteLine "<td align = " & Chr(34) & "right" & Chr(34) & ">" & GetJobSetupStockSizeZ & Chr(34) & "</td>"
    .WriteLine "</tr>"

    .WriteLine "</table>"

    .WriteLine "<BR><BR><BR><BR><PRE>"
    .WriteLine "<BR></PRE>"
    
    .WriteLine "<table align = " & Chr(34) & "left" & Chr(34) & "width ="  & Chr(34) & "85%" & Chr(34) & "border=" & Chr(34) & "1" & Chr(34) & "cellspacing=" & Chr(34) & "2" & Chr(34) & " cellpadding=" & Chr(34) & "2" & Chr(34) & " bordercolorlight=" & Chr(34) & "#C0C0C0" & Chr(34) & " bordercolordark=" & Chr(34) & "#A72934" & Chr(34) & ">"
    .WriteLine "<caption align=" & Chr(34) & "left" & Chr(34) & "><B>OPERATION TOOL LIST</B></caption>"
    .WriteLine "<th>OP#</th>"
    .WriteLine "<th>T#</th>"
    .WriteLine "<th>TO</th>"
    .WriteLine "<th>TLO</th>"
    .WriteLine "<th>TDIA</th>"
    .WriteLine "<th>TLEN</th>"
    .WriteLine "<th>MIN Z</th>"
    .WriteLine "<th>MAX Z</th>"
    .WriteLine "<th>OPERATION TYPE</th>"
    .WriteLine "<th>TOOL COMMENT</th>"
    .WriteLine "<th>OPERATION COMMENT</th>"

    ' -- Get current files operation count
    ' strCurrentFileName
    'intOpCount = GetOperationCount(vbNullString)
    intOpCount = GetOperationCount(strCurrentFileName)  

    'ShowString "Operation count = " & intOpCount

    ' -- Iterate all operations
    For intOperations = 0 To intOpCount-1

    ' -- Get our tool number
    'ToolNumber = GetToolNumberFromOperationID(vbNullString, intOperations)
    ToolNumber = GetToolNumberFromOperationID(strCurrentFileName, intOperations)
    
    'ShowString "Toolnumber = " & ToolNumber

    .WriteLine "<tr>"
        .WriteLine "<td align = " & Chr(34) & "center" & Chr(34) & ">" & intOperations & "</td>"
        .WriteLine "<td align = " & Chr(34) & "center" & Chr(34) & ">" & ToolNumber & "</td>"
        .WriteLine "<td align = " & Chr(34) & "center" & Chr(34) & ">" & GetToolDiameterOffsetNumber(ToolNumber) & "</td>"         
        .WriteLine "<td align = " & Chr(34) & "center" & Chr(34) & ">" & GetToolLengthOffsetNumber(ToolNumber) & "</td>" 
        .WriteLine "<td align = " & Chr(34) & "center" & Chr(34) & ">" & GetToolDiameter(ToolNumber) & "</td>"
        .WriteLine "<td align = " & Chr(34) & "center" & Chr(34) & ">" & GetToolLength(ToolNumber) & "</td>" 
        .WriteLine "<td align = " & Chr(34) & "center" & Chr(34) & ">" & FormatValue(GetNciMinZFromOperationID(strCurrentFileName, intOperations),4) & "</td>"
        .WriteLine "<td align = " & Chr(34) & "center" & Chr(34) & ">" & FormatValue(GetNciMaxZFromOperationID(strCurrentFileName, intOperations), 4) & "</td>"
        
        'ShowString "Before GetOperationTypeFromID"

         ' -- Get this operations type
         intOpTypeId = GetOperationTypeFromID(strCurrentFileName, intOperations) 

		'ShowString "After GetOperationTypeFromID = " & intOpTypeId

         ' -- What type of operation is it?
         Select Case intOpTypeId

                Case mcOPERATION_CONTOUR:               .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">CONTOUR</td>"     
                Case mcOPERATION_DRILL:                 .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">DRILL</td>"         
                Case mcOPERATION_POCKET:                .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">POCKET</td>"     
                Case mcOPERATION_ROUTER_BLOCK_DRILL:    .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">BLOCK DRILL</td>"          
                Case mcOPERATION_ROUTER_CNTR:           .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">ROUTER CONTOUR</td>"           
                Case mcOPERATION_ROUTER_CUTOFF:         .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">ROUTER CUTOFF</td>"           
                Case mcOPERATION_ROUTER_POCK:           .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">ROUTER POCKET</td>"         
                Case mcOPERATION_SRF_RGH_PARALLEL:      .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE ROUGH PARALLEL</td>"          
                Case mcOPERATION_SRF_RGH_RADIAL:        .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE ROUGH RADIAL</td>"           
                Case mcOPERATION_SRF_RGH_PROJECT:       .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE ROUGH PROJECT</td>"           
                Case mcOPERATION_SRF_RGH_FLOWLINE:      .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE ROUGH FLOWLINE</td>"         
                Case mcOPERATION_SRF_RGH_CONTOUR:       .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE ROUGH CONTOUR</td>"         
                Case mcOPERATION_SRF_RGH_POCKET:        .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE ROUGH POCKET</td>"           
                Case mcOPERATION_SRF_FIN_PARALLEL:      .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE FINISH PARALLEL</td>"         
                Case mcOPERATION_SRF_FIN_RADIAL:        .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE FINISH RADIAL</td>"          
                Case mcOPERATION_SRF_FIN_PROJECT:       .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE FINISH PROJECT</td>"        
                Case mcOPERATION_SRF_FIN_FLOWLINE:      .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE FINISH FLOWLINE</td>"        
                Case mcOPERATION_SRF_FIN_CONTOUR:       .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE FINISH CONTOUR</td>"          
                Case mcOPERATION_SRF_FIN_PENCIL:        .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE FINISH PENCIL TRACE</td>"           
                Case mcOPERATION_SRF_FIN_LEFTOVER:      .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE FINISH LEFTOVER STOCK</td>"         
                Case mcOPERATION_SRF_FIN_STEEP:         .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE FINISH STEEP</td>"           
                Case mcOPERATION_SRF_FIN_SHALLOW:       .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE FINISH SHALLOW</td>"          
                Case mcOPERATION_SRF_FIN_CONSCALOP:     .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE FINISH CONSTANT SCALOP</td>"      
                Case mcOPERATION_SRF_RGH_PLUNGE:        .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE ROUGH PLUNGE</td>"          
                Case mcOPERATION_SRF_FLOW5AX:           .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE FINISH 5AXIS FLOWLINE</td>"              
                Case mcOPERATION_SRF_4AX:               .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">SURFACE FINISH 4 AXIS</td>"                  
                Case mcOPERATION_MERGED_NCI:            .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">MERGED IN ASCII NCI</td>"               
                Case mcOPERATION_5AX_SWARF:             .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">5 AXIS SWARF</td>"               
                Case mcOPERATION_5AX_ROLLDIE:           .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">5 AXIS ROLL DIE</td>"              
                Case mcOPERATION_FACE:                  .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">FACE OPERATION</td>"    
                Case mcOPERATION_5AX_MSURF:             .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">5 AXIS MULTI SURFACE ROUGH</td>"   

                Case Else:                              .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">*UNKNOWN OPId* -> " & intOpTypeId & "</td>"  
         
        End Select


            strToolComment = GetToolComment(ToolNumber)
            
                        
            If Len(Trim(strToolComment)) = 0 Then
              .WriteLine "<td> -//- </td>"
            Else
              .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">" & strToolComment & "</td>"
            End If    
    
    
            strOpComment = GetOperationNameFromID(strCurrentFileName, intOperations)
            
                        
            If Len(Trim(strOpComment)) = 0 Then
              .WriteLine "<td> -//- </td>"
            Else
              .WriteLine "<td align = " & Chr(34) & "left" & Chr(34) & ">" & strOpComment & "</td>"
            End If
    
            .WriteLine "</tr>"

    Next

    .WriteLine "</FONT>" 
    .WriteLine "</BODY>"
    .WriteLine "</HTML>"  

.Close

End With

Call RepaintScreen(True)
Call ClearPromptLines   
Call WriteString("Launching report, please wait....")
Call ShowMe(strHTML)
Call ClearPromptLines                   

End Sub

' ////////////////////
' Function Declaration
' ////////////////////
Public Function ShowMe(sHTML)

On Error Resume Next
    
Dim objIE

' Create the IE object and sets some parameters 
Set objIE = CreateObject("InternetExplorer.Application")

If objIE Is Nothing Then Exit Function

If Err Then
   ShowString "Error loading Internet Explorer " & Err.Description
   Exit Function
End If

With objIE

    .Navigate sHTML
    .ToolBar = True
    .StatusBar = False
    .Resizable = True

    Do
    ' -- Zzzzzz....
    Loop While .Busy

    .Visible = True  

End With
          

Set objIE = Nothing

               
End Function
