'////////////////////////////////////////////////////////////////////////////////
'//
'//        Author:   Mick.George@Mastercam.com Mick George
'//          Date:   09/06/2009 03:45 PM
'//     File Name:   GetNCINames.VBS
'//
'//   Description:   Write out list of unique NCI names from operations manager
'//
'//      Comments:   No error checking!
'//
'//                  Verified version X8
'////////////////////////////////////////////////////////////////////////////////


Const NCI = "NCI.dat"


' -- Start Script
Call Main()


' ////////////////////
' Sub Declaration
' ////////////////////
Sub Main()
    

Dim intOpCount, idx, intCount, sNCIName
Dim nciList, nciItems, nciPath
Dim fso, tf



' -- How many operations do we have?              
intOpCount = GetOperationCount(vbNullString)

' -- Test
If intOpCount = 0 Then Exit Sub  

' -- Initialize
intCount = 0

' -- Create a dictionary object to store names
Set nciList = CreateObject("Scripting.Dictionary")
'
nciPath = vbNullstring

' -- Loop all operations
For idx = 0 To intOpCount - 1
    ' -- Get the NCI name
    sNCIName =  GetNciNameFromOperationID(vbNullString, idx) 
    
    ' -- Store the NCI destination
    If nciPath = vbNullstring Then
       nciPath  = ExtractPath(sNCIName) & NCI
    End If
    
    ' -- Have we already saved it?   
    If Not nciList.Exists(sNCIName) Then
       ' -- Save it to the list
       nciList.Add sNCIName, sNCIName 
    End If    
            
Next     

' -- Get the list
nciItems = nciList.Items

Set fso = CreateObject("Scripting.FileSystemObject")
Set tf = fso.CreateTextFile(nciPath, True)

' -- iterate the list
For idx = 0 To nciList.Count - 1 
	 ' -- Write to disk
	 Dim clean
	 clean = Ucase(ExtractFile(nciItems(idx)))
	 
  	 tf.WriteLine(Replace(clean, ".NCI", ".NC")) 
Next

tf.Close

End Sub



Function ExtractPath(vStrFullPath ) 
   Dim intPos 
   intPos = InStrRev(vStrFullPath, "\")
   ExtractPath = Mid(vStrFullPath, 1, intPos)
End Function
Function ExtractFile(vStrFullPath ) 
   Dim intPos 
   intPos = InStrRev(vStrFullPath, "\")

	If intPos = 0 Then
		ExtractFile = vStrFullPath
	Else
		'Assign filename only to variable
		ExtractFile = Right(vStrFullPath, Len(vStrFullPath) - intPos)
	End If


End Function
