'////////////////////////////////////////////////////////////////////////////////
'//
'//        Author:   Mick.George@Mastercam.com
'//          Date:   30/04/2003 03:13 PM
'//     File Name:   MS Excel Data.vbs
'//
'//   Description:   This script shows how to query Excel if installed on target machine
'//
'//                  Verified version X8
'////////////////////////////////////////////////////////////////////////////////

' -- Start Script
Call Main()


' ////////////////////
' Sub Declaration
' ////////////////////
Sub Main()

   ' On Error Resume Next

    Dim CellPart1, K, XLString1, CellPart2, CellPart3, CellPart4 
    Dim strData, strResults
    
    Dim xlExcel, xlWorkBook, xlWorkSheet
    
    ' -- Check for Excel first
    Set xlExcel = CreateObject("Excel.Application")
    
    If xlExcel Is Nothing Then
       ShowString "Excel is not installed on this PC"
       Exit Sub
    End If     
      
    ' -- Prompt for a file
    If Not AskForFileName(".XLS", mcFILE_ACCESS_READ , strData)  Then Exit Sub     

    ' -- Get the workbook
    Set xlWorkBook = xlExcel.Workbooks.Open(strData)
     
    ' -- Get the first worksheet
    Set xlWorkSheet = xlWorkbook.Worksheets(1)
     
    ' -- Loop 19 rows 
    For K = 1 To 19
     
         CellPart1 = "A"& K
         CellPart2 = "B"& K
         CellPart3 = "C"& K
         CellPart4 = "D"& K
            
         strResults = xlWorkSheet.Range(CellPart1).Text & " is in " & CellPart1 &  vbCrLf & _
                      xlWorkSheet.Range(CellPart2).Text & " is in " & CellPart2 &  vbCrLf & _
                      xlWorkSheet.Range(CellPart3).Text & " is in " & CellPart3 &  vbCrLf & _
                      xlWorkSheet.Range(CellPart4).Text & " is in " & CellPart4
    
         ShowString strResults
    
     Next
     
   ' -- Cool?  
   If Err Then
      ShowString "Error occured in Sub Main: " & Err.Description
   End If
   
  ' -- Release Excel  
  If Not xlExcel Is Nothing Then
      xlExcel.Quit
      Set xlExcel = Nothing
   End If        
   
   
End Sub