'////////////////////////////////////////////////////////////////////////////////
'//
'//        Author:   mick.george@mastercam.com
'//          Date:   23/02/2007 10:47 AM
'//     File Name:   Post a whole directory of MCX files.vbs
'//
'//   Description:   Mastercam VB Script
'//
'//      Comments:   
'//
'////////////////////////////////////////////////////////////////////////////////

' -- Start Script
Call Main()


' ////////////////////
' Sub Declaration
' ////////////////////
Sub Main()

' ***************************************************
' * This function will open the NC file for the nest
' ***************************************************
 
Dim strOutputFolder
Dim FSO, fsoMCX, fsoFiles, fsoNCFile

Set FSO = CreateObject("Scripting.FileSystemObject")
  
' -- Get MCX folder 
strOutputFolder = BrowseForFolder("Select folder containing MCX-8 files")
If FSO.FolderExists(strOutputFolder) Then 
   
   	Set fsoMCX = FSO.GetFolder(strOutputFolder) 
	strOutputFolder = BrowseForFolder("Select folder for NC Output files")
	If FSO.FolderExists(strOutputFolder) Then 
		Set fsoFiles = fsoMCX.Files
 	   	' -- Iterate all files per folder 
  	  	For Each fsoMCX In fsoFiles   
       	' -- Only looking for MCX files
       	If Right(ucase(fsoMCX.Name), 5) =  "MCX-8" Then
        	' -- Open it
          	Call NewMC(false)
          	Call OpenMC(fsoMCX)
			' -- Post it
	      	Call RunPostAll(strOutputFolder, false)
    	End If
    	Next
    End If
End If

' -- Clean up
Set fsoNCFile = Nothing
Set fsoFiles = Nothing
Set FSO = Nothing

End Sub



' //////////////////////////////////////////
' Function Declaration
' Returns vbNullString if no folder selected
' //////////////////////////////////////////

Function BrowseForFolder(strPrompt)

    On Error Resume Next

    Dim objShell, objFolder, intColonPos, objWshShell
    Dim FSO, varTemp

    ' -- Create our all important objects
    Set objWshShell = CreateObject("WScript.Shell")
    Set objShell = CreateObject("Shell.Application")
    Set FSO = CreateObject("Scripting.FileSystemObject")

    Set objFolder = objShell.BrowseForFolder(&H0&, strPrompt, &H1&)

    ' -- Initialize to failure
    BrowseForFolder = vbNullString
    
    ' -- Did the user Cancel?
    If Not objFolder Is Nothing Then
    
        Select Case objFolder.Title
               
               ' -- Did the user select Desktop?
               Case "Desktop"
                   BrowseForFolder = objWshShell.SpecialFolders("Desktop")
               
               Case Else
                    ' -- Get the folder selected
                    varTemp = objFolder.ParentFolder.ParseName(objFolder.Title).Path
                    
                    ' -- If the user does not select a folder or cancels out an error is raised
                    If Err Then
                    
                       Select Case Err.Number
                              ' -- Probably root drive selected e.g. (C:)
                              Case 91, 424
                                    ' -- Check for Root
                                    intColonPos = InStr(objFolder.Title, ":")
                                
                                    If intColonPos > 0 Then
                                       BrowseForFolder = Mid(objFolder.Title, intColonPos - 1, 2) & "\"
                                    End If
                               
                               Case Else
                               
                        End Select
                        
                        Err.Clear
                        
                    Else
                        ' -- If we get this far make sure the folder exists
                        ' -- selecting a network folder may result in an invalid folder
                        If FSO.FolderExists(varTemp) Then BrowseForFolder = varTemp
                    End If
                    
         End Select
    End If

    ' -- Check for an error of any kind
    If Err Then
       BrowseForFolder = vbNullString
       ShowString "Error selecting folder: " & Err.Description, vbExclamation, "BrowseForFolder"
       Err.Clear
       Exit Function
     End If
     
' -- Clean up
Set objWshShell = Nothing
Set objShell = Nothing
Set objFolder = Nothing
Set FSO = Nothing
     
     
     
End Function
