'////////////////////////////////////////////////////////////////////////////////
'//
'//        Author:   Mick.George@Mastercam.com
'//          Date:   10/02/2003 02:11 PM
'//     File Name:   PrintLevelList.vbs
'//
'//   Description:   Outputs level names to text
'//
'//      Comments:    
'//
'//                  Verified version X8
'////////////////////////////////////////////////////////////////////////////////

'///////////////// My Constants /////////////////
Public Const DEF_NOTEPAD        = "C:\Windows\Notepad.exe"
Public Const DEF_NOTEPAD_NT     = "C:\WINNT\Notepad.exe" 
Public Const DEF_LIST           = "mcLevelList.txt"
Public Const DEF_ALL_LEVELS     = 255

' -- Start Script
Call Main()


' ////////////////////
' Sub Declaration
' ////////////////////
Sub Main()

Dim intCurrentLevel, strCurrentLevelName()
Dim FSO, fsoLevelsList, intCount, strTemp, strShell
  

intCount = -1                  

' -- Iterate all levels
For intCurrentLevel = 1 To DEF_ALL_LEVELS

    strTemp =  Trim(GetLevelName(intCurrentLevel))

    ' -- Is this level named?
    If Len(strTemp) <> 0 Then
       ' -- Resize our array
       intCount = intCount + 1
       ReDim Preserve strCurrentLevelName(intCount)
       ' -- Assign level name and nunber
       strCurrentLevelName(intCount) = "Level #" & intCurrentLevel & " = " & strTemp
    End If
Next

' -- Test
If intCount = -1 Then
   ' -- No named levels found
   ShowString "No named levels found in current drawing"
Else

   Set FSO = CreateObject("Scripting.FileSystemObject")

   Set fsoLevelsList = FSO.CreateTextFile(GetPathOfThisScript & DEF_LIST)

   For intCurrentLevel = 0 To intCount
       fsoLevelsList.WriteLine  strCurrentLevelName(intCurrentLevel)
   Next

   fsoLevelsList.Close


    ' -- Where is Notepad?    
    If FSO.FileExists(DEF_NOTEPAD) Then
       strShell = DEF_NOTEPAD 
    ElseIf FSO.FileExists(DEF_NOTEPAD_NT) > 0 Then
       strShell = DEF_NOTEPAD_NT
    Else
       strShell = vbNullString 
    End If                      
    
    ' -- Are we ok?
    If Len(strShell) = 0 Then
       'EditFile GetPathOfThisScript & "mcLevelList.txt" 
       ' -- Stays modal to mc    
    Else          
        ' -- Ok, show the file  
        strShell = strShell & " " & GetPathOfThisScript & DEF_LIST         
        Call ShellAndWait (strShell, False)           
    End If

    ' -- Clean up
    Erase strCurrentLevelName


End If


' -- Clean up
Set FSO = Nothing
Set fsoLevelsList = Nothing

End Sub