'////////////////////////////////////////////////////////////////////////////////
'//
'//        Author:   Mick George Mick.George@Mastercam.com
'//          Date:   14/02/2003 09:22 AM
'//     File Name:   Prompt Rectangle.vbs
'//
'//   Description:   Prompt for a diameter and height, if values are ok then 
'//                  create a rectangle.
'//      Comments:    
'//
'//                  Verified version X8
'////////////////////////////////////////////////////////////////////////////////  


Public Const DEF_SPACE = "        "
Public Const DEF_PI    = 3.14159
                                   


' -- Start Script
Call Main()


' ////////////////////
' Sub Declaration
' ////////////////////
Sub Main()       
   
Dim dblDiameter 
Dim dblResult
Dim dblHeight
Dim strTemp
Dim objRectangle  
Dim blnOK  


' -- Prompt user to clear screen
Select Case askYesNoCancel("Are you sure you want to initialize geometry and operations?" & DEF_SPACE)     

       Case mcMSG_CANCEL
            ' -- Bail...
            Exit Sub  
       Case mcMSG_NO
            ' -- Do nothing...

       Case mcMSG_YES
            ' -- Clear the screen
            Call NewMC(False)

End Select


' -- Prompt for a diameter
If Not askValue ("Please input a diameter", 0 , 1000, dblDiameter) Then
   ' -- User failed to input a value between 0-1000  
   Exit Sub
End If

' -- Prompt for a diameter
If Not askValue("Please input a height", 0 , 1000, dblHeight) Then
   ' -- User failed to input a value between 0-1000  
   Exit Sub
End If

' -- Assign values to our Rectangle class   
Set objRectangle = New McRe

dblResult = (DEF_PI * dblDiameter)

With objRectangle

     .X1 = 0
     .Y1 = 0
     .X2 = dblResult
     .Y2 = dblHeight
     .Z  = 0

End With     

' -- Created OK?
If CreateRectangle(objRectangle, mcCONSTRUCTION_COLOR_CURRENT, mcCONSTRUCTION_LEVEL_CURRENT) =mcENTITY_INVALID Then
   ShowString "Could not create rectangle"

End If

' -- Zoom All
Call RepaintScreen(True) 

' -- Clean up
Set objRectangle = Nothing   


End Sub