'////////////////////////////////////////////////////////////////////////////////
'//
'//        Author:   Mick George Mick.George@Mastercam.com
'//          Date:   15/03/2004 09:16 AM
'//     File Name:   SetAllOperationsDirty.vbs
'//
'//   Description:   Iterate all operations in current drawing, set all operations clean if any are dirty.
'//
'//      Comments:   Requires March Maintenance release
'//                  Validated X8
'//
'////////////////////////////////////////////////////////////////////////////////

' -- Start Script
Call Main()


' ////////////////////
' Sub Declaration
' ////////////////////
Sub Main()
    

Dim intOpCount, idx, intCount

' -- How many operations do we have?              
intOpCount = GetOperationCount(vbNullString)

' -- Test
If intOpCount = 0 Then ShowString "No operations in current drawing": Exit Sub  

' -- Initialize
intCount = 0

' -- Let's see how many operations are dirty before we do anything
For idx = 1 To intOpCount 
    If GetOperationDirtyFromID(vbNullString, idx) Then
       intCount = intCount + 1
    End If     
Next        

' -- Test
If intCount  = 0 Then
   ShowString "No operations are dirty"
Else
   ShowString intCount & " operations are currently dirty, we will now set all of them 'clean'"
End If

If intCount > 0 Then
	For idx = 1 To intOpCount
		 If Not SetOperationDirtyFromID(vbNullString, idx, False) Then
		    ShowString "Could not 'clean' operation # " & idx
		 Else
		    Call RegenOp(idx)   
		 End If
	Next  
End If


    
    
    
End Sub