'////////////////////////////////////////////////////////////////////////////////
'//
'//        Author:   Mick.George@Mastercam.com
'//          Date:   06/2008
'//     File Name:   SetAllOperationsLocked.vbs
'//
'//   Description:   Iterate all operations in current drawing, set all operations Locked.
'//
'//      Comments:   Requires March Maintenance release
'//                  Validated X8
'//
'////////////////////////////////////////////////////////////////////////////////

' -- Start Script
Call Main()


' ////////////////////
' Sub Declaration
' ////////////////////
Sub Main()
    

Dim intOpCount, idx, intCount

' -- How many operations do we have?              
intOpCount = GetOperationCount(vbNullString)

' -- Test
If intOpCount = 0 Then ShowString "There are no operations in current drawing": Exit Sub  

' -- Initialize
intCount = 0

' -- Let's see how many operations are locked before we do anything
For idx = 1 To intOpCount 
    If GetOperationLockedFromID(vbNullString, idx) Then
       intCount = intCount + 1
    End If     
Next        

' -- Test
If intCount  = 0 Then
   ShowString "No operations are currently locked."
Else
   ShowString intCount & " operations are currently locked, we will unlocked all operations."
End If

If intCount > 0 Then
	' -- Turn off all ops 
	For idx = 1 To intOpCount
	 If Not SetOperationLockedFromID(vbNullString, idx, False) Then
	    ShowString "Could not unlock operation # " & idx
	 Else
	   Call RegenOp(idx)   
	 End If
	Next 
End If

intCount = 0

If askYesNo("Do you wish to lock all operations?") Then

' -- Select every  operation 
For idx = 1 To intOpCount 
        
 If SetOperationLockedFromID(vbNullString, idx, True) Then
    ' -- Success
    intCount = intCount + 1
    Call RegenOp(idx)
 Else
    ShowString "Could not set operation # " & idx & " locked"
 End If

Next        

If intCount > 0 Then
   ShowString intCount & " operations locked from " & intOpCount &  " total operations"
End If   

End If    
    
    
End Sub