'////////////////////////////////////////////////////////////////////////////////
'//
'//        Author:   Mick.George@Mastercam.com
'//          Date:   28/10/2003 08:39 AM
'//     File Name:   bolt-hole-pattern.vbs
'//
'//   Description:   Gets/Sets background colour.
'//
'//      Comments:   Validated version X8
'//
'////////////////////////////////////////////////////////////////////////////////

' -- Start Script
Call Main()


' ////////////////////
' Sub Declaration
' ////////////////////
Sub Main()         


On Error Resume Next

     ' -- Declare the objects
Dim objctrpoint   
Dim objcircle
Dim objsmlhole
Dim bRet  ' whatever the user picks 
Dim intCounter  ' counts holes around circle 
Dim angle
Dim angval
Dim radvalue 
Dim diavalue
Dim numholes

   ' -- Prompt the user for pattern centre

     ' -- Create  dummy point& arc objects
     Set objctrpoint = New McPt  
     Set objcircle = New McAr  
     
     ' -- Prompt to clear screen if applicable
     Call InitializeScreen()
            
     ClearPromptLines()  ' clear prompt line

     ' -- Ask for the first point 
     Call ShowString("Select centre point of bolt hole pattern")    


     If askPoint(objctrpoint) Then

       ' -- If ok lets get the radius 
        If askValue("Pattern radius?",0,100,radvalue) Then 
            ' -- If ok lets get the small hole diameter
            If askValue("drill hole dia?",0,100,diavalue) Then 
                ' -- If ok lets get the number of holes
                If askValue("How many holes?",0,100,numholes) Then 
                 ' -- If we are here then we have all the info we need 
                    Set objcircle = New McAr ' pattern drill holes
                    angval=6.283185307/numholes  ' incremental angle in radians 

                    With objcircle   ' set constant values 

                    .R = diavalue 
                    .SA= 0.
                    .SW= 360
                    .Z = objctrpoint.Z 
                    angle=0  ' start angle

                    For intCounter = 1 To numholes
                        ' -- Assign the co-ords
                        .X = objctrpoint.X+radvalue*Cos(angle)
                        .Y = objctrpoint.Y +radvalue*Sin(angle)
                        angle=angle+angval   ' increment to next angular position
                        bret=CreateArc(objcircle,mcCONSTRUCTION_COLOR_CURRENT, mcCONSTRUCTION_LEVEL_CURRENT)         
                    Next 

                    End With  

                    Call RepaintScreen(True)

                Else
                ' -- Problem!
                ShowString "wrong number of holes"
            End If       
            Else
          ' -- User cancelled or failed to input hole diameter.
          ShowString "wrong hole diameter"
       End If 
    Else
          ' -- User cancelled or failed to input pattern diameter.
          ShowString "wrong pattern diameter"
       End If 
     Else
          ' -- User cancelled or failed to enter pattern radius.
          ShowString "User failed to select the first point"
     End If  


' -- Check for an error
If Err Then
   Call ShowString("An error has occured in this script" & vbCrLf & Err.Description)
End If


' -- Clean up
Set objctrpoint = Nothing
Set objSecondPoint = Nothing  
Set objcircle = Nothing

End Sub

' ////////////////////
' Function Declaration
' ////////////////////
Function InitializeScreen()

If askYesNo("Clear memory?") Then
   Call NewMC(false)
End If 

End Function
